import sublime
import sublime_plugin
import os
import sys
import subprocess
__dir__ = os.path.dirname(os.path.realpath(__file__));
found_directory = False;
for index, item in enumerate(sys.path):
  if item == __dir__:
    found_directory = True;
if found_directory == False:
  sys.path.insert(1, __dir__)

class FcfGetPathCommand(sublime_plugin.WindowCommand):
  def __init__(self, view):
    super(FcfGetPathCommand, self).__init__(view)

  def is_enabled_(self, args):    
    return True

  def run(self, **args):
    path = None

    try:
      if len(args["dirs"]) != 0:
        path = args["dirs"][0]
      elif len(args["files"]) != 0:
        path = args["files"][0]
    except:
      return

    if path == None:
      return
 
    try:
      import pyperclip
      pyperclip.copy(path)
    except:
      import pyp3rclip
      pyp3rclip.copy(path)



class FcfNewTemplateCommand(sublime_plugin.WindowCommand):
  def __init__(self, window):
    super(FcfNewTemplateCommand, self).__init__(window)
    self._directory = None
    self._args      = None
    self._template  = None

  def run(self, **args):
    try:
      self._directory = ""
      self._args      = {"file": ""}
      self._template  = args["fcftemplate"]
      if len(args["dirs"]) != 0:
        self._directory = args["dirs"][0]
      elif len(args["files"]) != 0:
        self._directory = os.path.dirname(args["files"][0])
    except:
      return True

    if self._directory == None:
      return

    self.window.show_input_panel("Enter file name:", "", self._onDoneInput, None, None)

  def _onDoneInput(self, inputString):
    self._args["file"] = inputString.strip();
    self._action();
    return


  def _action(self):
    try:
      if len(self._directory) == 0:
        return
      if len(self._args["file"]) == 0:
        return
      subprocess.Popen(["fcfmngr", "c", self._template, self._args["file"]], cwd=self._directory)
    except e:
      print(e)
